#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/sctp.h>
#include <arpa/inet.h>

void
check_return_value(int value,char * error_message)
{
	if(value == -1)
	{
		perror(error_message);
		exit(1);
	}
}

int
create_sctp_socket(struct sockaddr_in * socket_definition,char * server_address, int server_port)
{
	bzero( (void *)socket_definition, sizeof(socket_definition) );
	socket_definition->sin_family = AF_INET;
	socket_definition->sin_port = htons(server_port);
	socket_definition->sin_addr.s_addr = inet_addr(server_address);
	return socket( AF_INET, SOCK_STREAM, IPPROTO_SCTP );
}

int
set_sctp_server_options(int mysocket)
{
	struct sctp_initmsg sctp_config;

	memset( &sctp_config, 0, sizeof(sctp_config) );
	sctp_config.sinit_num_ostreams = 5;
	sctp_config.sinit_max_instreams = 5;
	sctp_config.sinit_max_attempts = 4;
	return setsockopt(mysocket, IPPROTO_SCTP, SCTP_INITMSG, &sctp_config, sizeof(sctp_config) );
}
int
connection_to_server(int mysocket,struct sockaddr_in socket_definition)
{
	return connect( mysocket,(struct sockaddr *) &socket_definition, sizeof(socket_definition) );
}

int
send_message_unsafe(int mysocket, char * message)
{
	return sctp_sendmsg( mysocket, (void *)message, (size_t)strlen(message), NULL, 0, 0, 0, 0, 0, 0 );
}

