#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netinet/sctp.h>
#include "sctp_functions.h"

int 
main(int argc, char ** argv)
{
	int listener, client_connection, listener_status;
	struct sockaddr_in server_address;
	struct sctp_sndrcvinfo sndrcvinfo;
 
	listener = create_sctp_socket(&server_address,"127.0.0.1",62324);
 
	listener_status = bind( listener, (struct sockaddr *)&server_address, sizeof(server_address) );
	check_return_value(listener_status,"Error : Bind");
 
	listener_status = set_sctp_server_options(listener); 
	check_return_value(listener_status,"Error : Bind");
	
	listen( listener, 5 );
 
	while( 1 )
	{
		char message[1024];
		int message_status, flags ; 
 
		printf("Awaiting connections\n");
 
		client_connection = accept( listener, NULL, NULL );
		check_return_value(client_connection, "Error : Accept");
  
		message_status = sctp_recvmsg( client_connection, message, sizeof(message), NULL, 0, &sndrcvinfo, &flags );
		printf(" Data : %s\n", (char*)message);
  
		close( client_connection );
	}
 
	exit(0);
}
